#!/usr/bin/python
__version__ = "$Revision: 1.0 $"
__author__ = "EI5a, eivd, SimTaxi (Groupe Burdy)"
__date__ = "2002-11-23"

from wxPython.wx import *
from OpenglCanvas import *
from Taxi import *
from Route import *
from Carrefour import *
from Grille import *
from Limite import *

class AffichageOpenGL(OpenGLCanvas):
    """
    Canevas de dessin
    
    Gestion de l'affichage OpenGL
    
    :version: $Revision 1.0 $
    :author: Gregory Burri 
    """

        
    def InitGL(self):

        glEnable(GL_CULL_FACE) #active l'effacement des faces caches
        glFrontFace(GL_CW) #definit la face visible
        glCullFace(GL_FRONT) #on cache certaines faces (les faces devants)
        
        glEnable(GL_DEPTH_TEST); #active le Z-Buffer
        
        
               
        self.route = Route(7)

        self.carrefour = Carrefour(8)
        
        self.taxi = Taxi(9)
       
        self.grille1 = Grille(1, (0.2, 0.2, 0.2), 10.0)        
        self.grille2 = Grille(2, (0.4, 0.4, 0.1), 100.0)
        self.grille3 = Grille(3, (0.2, 0.2, 0.7), 1000.0)
        
        self.limite = Limite(4)
        
    #>-----------------------------------------------------------------------
    def evRedessiner(self):
        # clear color and depth buffers
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

        self.taxi.dessiner((5, 5), (-1, -1))
        self.taxi.dessiner((4.0, 13.0), (-12.0-20.0, 6.0-20.0))
        
        self.route.dessiner((-20.0, -20.0), (20.0, 20.0)) 
        self.route.dessiner((20.0, 20.0), (-12.0, 6.0)) 
        self.route.dessiner((-12.0, 6.0),(-20.0, -20.0)) 
        
        self.route.dessiner((20.0, 20.0),(-5.0, 22.0))
        self.route.dessiner((-5.0, 22.0),(-12.0, 6.0))
        
        self.carrefour.dessiner((-20.0, -20.0)) 
        self.carrefour.dessiner((20.0, 20.0)) 
        self.carrefour.dessiner((-12.0, 6.0)) 
        self.carrefour.dessiner((-5.0, 22.0))        
        
        size = self.GetClientSize()
        point1 = (-size.width/2.0/self.zoom+self.position[0],
                  -size.height/2.0/self.zoom+self.position[1])
        point2 = (size.width/2.0/self.zoom+self.position[0],
                  size.height/2.0/self.zoom+self.position[1])  
                  
        if self.zoom > 0.8 :
            self.grille1.dessiner(point1, point2)     
        if self.zoom > 0.2 :                           
            self.grille2.dessiner(point1, point2)
        self.grille3.dessiner(point1, point2)
        
        self.limite.dessiner(self.positionMax, self.positionMin)
        
        self.SwapBuffers()
        
        
        
        
        
