
from OpenGL.GL import *
from OpenGL.GLUT import *
    
from wxPython.wx import *
from ObjetGraph import *

from math import *

class Route(ObjetGraph):
    def __init__(self, couche=0, couleur=(0.6, 0.6, 0.6)):
        ObjetGraph.__init__(self)
        self.couleur = couleur
        self.couche = couche
        
    def dessiner(self, debut, fin):
        
        glColor3f(self.couleur[0], self.couleur[1], self.couleur[2]);
        
        glPushMatrix()
                
        glBegin(GL_LINES)
        glVertex3f(debut[0], debut[1], self.hauteur())
        glVertex3f(fin[0], fin[1], self.hauteur())
        glEnd()
        
        centre = (debut[0] + (fin[0] - debut[0]) / 2.0  , debut[1] + (fin[1] - debut[1]) / 2.0)
        longueur = sqrt(pow(debut[0]-fin[0], 2) + pow(debut[1]-fin[1], 2))
       
        glTranslatef(centre[0], centre[1], self.couche/10);
           
        alpha = atan2((debut[1]-fin[1]), (debut[0]-fin[0]))
        glRotatef(alpha*180/pi, 0, 0, 1)

        #le taxi
        glBegin(GL_QUADS)
        glVertex3f(-longueur/2, -0.5, self.hauteur())
        glVertex3f(longueur/2, -0.5, self.hauteur())
        glVertex3f(longueur/2, 0.5, self.hauteur())
        glVertex3f(-longueur/2, 0.5, self.hauteur())
        glEnd()

       
        
        glPopMatrix()

